/*

 MatrixFormsEditor.java
 
 Copyright 2004 KUBO Hiroya (hiroya@sfc.keio.ac.jp).
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 
 http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 
 Created on 2004/07/30

 */
package net.sf.sqs_xml.editor.sqs.modules;

import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

import net.sf.sqs_xml.editor.base.modules.ContainerEditor;
import net.sf.sqs_xml.editor.base.modules.panel.AbstractNodeEditorPanel;
import net.sf.sqs_xml.editor.base.modules.resource.EditorResource;
import net.sf.sqs_xml.editor.base.source.DOMTreeSource;
import net.sf.sqs_xml.editor.base.swing.SourceEditorMediator;
import net.sf.sqs_xml.editor.sqs.modules.panel.MatrixFormsWidthRatioPanel;
import net.sf.sqs_xml.xmlns.SQSNamespaces;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 * @author hiroya
 *  
 */
public class MatrixFormsEditor extends AbstractFormEditor {
    public static final long serialVersionUID = 0;
    AbstractNodeEditorPanel widthRatioPanel;
    public MatrixFormsEditor(SourceEditorMediator mediator, DOMTreeSource source, Node node, EditorResource resource) {
        super(mediator, source, node, resource);
        widthRatioPanel = new MatrixFormsWidthRatioPanel(this);
        add(widthRatioPanel);
        Node rowArray = ((Element)node).getElementsByTagNameNS(SQSNamespaces.SQS2004_URI, "row-array").item(0);
        Node columnArray = ((Element)node).getElementsByTagNameNS(SQSNamespaces.SQS2004_URI, "column-array").item(0);
        JTabbedPane tabbedPane = new JTabbedPane();
        JScrollPane rowArrayScrollPane = new JScrollPane(new ContainerEditor(mediator, source,
                rowArray,
                mediator.getCurrentTreePane().getEditorResourceFactory().
                getEditorResource("row-array", SQSNamespaces.SQS2004_URI)));
        rowArrayScrollPane.getVerticalScrollBar().setUnitIncrement(8);
        
        JScrollPane columnArrayScrollPane = new JScrollPane(new ContainerEditor(mediator, source,
                columnArray,
                mediator.getCurrentTreePane().getEditorResourceFactory().
                getEditorResource("column-array", SQSNamespaces.SQS2004_URI)));
        columnArrayScrollPane.getVerticalScrollBar().setUnitIncrement(8);//(int)(columnArrayScrollPane.getHeight())      
        tabbedPane.add("行の定義", rowArrayScrollPane);
        tabbedPane.add("列の定義", columnArrayScrollPane);
        add(tabbedPane);
        addPreferredHeight(widthRatioPanel.getPreferredHeight()*3);
        initSize();
    }

    public boolean updateNodeValue() {
        if(super.updateNodeValue() || widthRatioPanel.updateNodeValue()){
            super.updateNodeValue(true);
            return true;
        }else{
            return false;
        }
    }
}